Index: /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/TOP_SRC/trcsub.F90
===================================================================
--- /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/TOP_SRC/trcsub.F90	(revision 7953)
+++ /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/TOP_SRC/trcsub.F90	(revision 7954)
@@ -2,5 +2,5 @@
    !!======================================================================
    !!                       ***  MODULE trcsubstp  ***
-   !!TOP :   Averages physics variables for TOP substepping. 
+   !!   TOP :   Averages physics variables for TOP substepping. 
    !!======================================================================
    !! History :  1.0  !  2011-10  (K. Edwards)  Original
@@ -8,18 +8,19 @@
 #if defined key_top
    !!----------------------------------------------------------------------
-   !!   trc_sub    : passive tracer system sub-stepping 
+   !!   trc_sub       : passive tracer system sub-stepping 
    !!----------------------------------------------------------------------
-   USE oce_trc          ! ocean dynamics and active tracers variables
+   USE oce_trc        ! ocean dynamics and active tracers variables
    USE trc
-   USE prtctl_trc       ! Print control for debbuging
-   USE iom
-   USE in_out_manager
-   USE lbclnk
-   USE trabbl
+   USE trabbl         ! bottom boundary layer
    USE zdf_oce
    USE domvvl
-   USE divhor          ! horizontal divergence            (div_hor routine)
-   USE sbcrnf    , ONLY: h_rnf, nk_rnf    ! River runoff
-   USE bdy_oce   , ONLY: ln_bdy, bdytmask ! BDY
+   USE divhor         ! horizontal divergence
+   USE sbcrnf   , ONLY: h_rnf, nk_rnf    ! River runoff
+   USE bdy_oce  , ONLY: ln_bdy, bdytmask ! BDY
+   !
+   USE prtctl_trc     ! Print control for debbuging
+   USE in_out_manager ! 
+   USE iom
+   USE lbclnk
 #if defined key_agrif
    USE agrif_opa_update
@@ -29,18 +30,51 @@
    IMPLICIT NONE
 
-   PUBLIC   trc_sub_stp      ! called by trc_stp
-   PUBLIC   trc_sub_ini      ! called by trc_ini to initialize substepping arrays.
-   PUBLIC   trc_sub_reset    ! called by trc_stp to reset physics variables
-   PUBLIC   trc_sub_ssh      ! called by trc_stp to reset physics variables
-
-   REAL(wp)  :: r1_ndttrc     !    1 /  nn_dttrc 
-   REAL(wp)  :: r1_ndttrcp1   !    1 / (nn_dttrc+1) 
-
-   !                                                       !* iso-neutral slopes (if l_ldfslp=T)
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)   ::  uslp_temp, vslp_temp, wslpi_temp, wslpj_temp   !: hold current values 
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)   ::  uslp_tm  , vslp_tm  , wslpi_tm  , wslpj_tm     !: time mean 
+   PUBLIC   trc_sub_stp     ! called by trc_stp
+   PUBLIC   trc_sub_ini     ! called by trc_ini to initialize substepping arrays.
+   PUBLIC   trc_sub_reset   ! called by trc_stp to reset physics variables
+   PUBLIC   trc_sub_ssh     ! called by trc_stp to reset physics variables
+
+   REAL(wp) :: r1_ndttrc     ! = 1 /  nn_dttrc 
+   REAL(wp) :: r1_ndttrcp1   ! = 1 / (nn_dttrc+1) 
+
+
+   !! averaged and temporary saved variables  (needed when a larger passive tracer time-step is used)
+   !! ----------------------------------------------------------------
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)   ::    un_tm ,   un_temp   !: i-horizontal velocity average     [m/s]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)   ::    vn_tm ,   vn_temp   !: j-horizontal velocity average     [m/s]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)   ::              wn_temp   !: hold current values of avt, un, vn, wn
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:,:) ::   tsn_tm ,  tsn_temp   !: t/s average     [m/s]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)   ::   avs_tm ,  avs_temp   !: vertical diffusivity coeff. at  w-point   [m2/s]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)   ::  rhop_tm , rhop_temp   !: 
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::  sshn_tm , sshn_temp   !: average ssh for the now step [m]
+
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::    rnf_tm ,    rnf_temp   !: river runoff
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::  h_rnf_tm ,  h_rnf_temp   !: depth in metres to the bottom of the relevant grid box
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::   hmld_tm ,   hmld_temp   !: mixed layer depth average [m]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::   fr_i_tm ,   fr_i_temp   !: average ice fraction     [m/s]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::    emp_tm ,    emp_temp   !: freshwater budget: volume flux [Kg/m2/s]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     :: fmmflx_tm , fmmflx_temp   !: freshwater budget: freezing/melting [Kg/m2/s]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     :: emp_b_hold,  emp_b_temp   !: hold emp from the beginning of each sub-stepping[m]  
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::    qsr_tm ,    qsr_temp   !: solar radiation average [m]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::   wndm_tm ,   wndm_temp   !: 10m wind average [m]
+   !
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::  sshb_hold   !:hold sshb from the beginning of each sub-stepping[m]  
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::   sshb_temp, ssha_temp
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)   ::  hdivn_temp, rotn_temp
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)   ::  hdivb_temp, rotb_temp
+   !
+   !                                                    !!- bottom boundary layer param (ln_trabbl=T)
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)     ::  ahu_bbl_tm, ahu_bbl_temp  ! BBL diffusive i-coef.
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)     ::  ahv_bbl_tm, ahv_bbl_temp  ! BBL diffusive j-coef.
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)     ::  utr_bbl_tm, utr_bbl_temp  ! BBL u-advection
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)     ::  vtr_bbl_tm, vtr_bbl_temp  ! BBL v-advection
+
+   !                                                      !!- iso-neutral slopes (if l_ldfslp=T)
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   uslp_temp, vslp_temp, wslpi_temp, wslpj_temp   !: hold current values 
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   uslp_tm  , vslp_tm  , wslpi_tm  , wslpj_tm     !: time mean 
+
 
    !!----------------------------------------------------------------------
-   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
+   !! NEMO/TOP 4.0 , NEMO Consortium (2017)
    !! $Id$ 
    !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
@@ -57,7 +91,8 @@
       !!              on TOP steps, calculate averages.
       !!-------------------------------------------------------------------
-      INTEGER, INTENT( in ) ::  kt        ! ocean time-step index
-      INTEGER               ::  ji,jj,jk  ! dummy loop indices
-      REAL(wp)              ::  z1_ne3t, z1_ne3u, z1_ne3v, z1_ne3w
+      INTEGER, INTENT( in ) ::   kt   ! ocean time-step index
+      !
+      INTEGER ::   ji, jj, jk   ! dummy loop indices
+      REAL(wp)::   z1_ne3t, z1_ne3u, z1_ne3v, z1_ne3w   ! local scalars
       !!-------------------------------------------------------------------
       !
@@ -74,15 +109,14 @@
            r1_ndttrc        = 1._wp / REAL( nn_dttrc    , wp ) 
            r1_ndttrcp1      = 1._wp / REAL( nn_dttrc + 1, wp )
-           !
       ENDIF  
 
-       IF( MOD( kt , nn_dttrc ) /= 0 ) THEN
-          !
-          un_tm   (:,:,:)        = un_tm   (:,:,:)        + un   (:,:,:)        * e3u_n(:,:,:) 
-          vn_tm   (:,:,:)        = vn_tm   (:,:,:)        + vn   (:,:,:)        * e3v_n(:,:,:) 
-          tsn_tm  (:,:,:,jp_tem) = tsn_tm  (:,:,:,jp_tem) + tsn  (:,:,:,jp_tem) * e3t_n(:,:,:)  
-          tsn_tm  (:,:,:,jp_sal) = tsn_tm  (:,:,:,jp_sal) + tsn  (:,:,:,jp_sal) * e3t_n(:,:,:)  
-          rhop_tm (:,:,:)        = rhop_tm (:,:,:)        + rhop (:,:,:)        * e3t_n(:,:,:)  
-          avs_tm  (:,:,:)        = avs_tm  (:,:,:)        + avs  (:,:,:)        * e3w_n(:,:,:)  
+      IF( MOD( kt , nn_dttrc ) /= 0 ) THEN
+         !
+         un_tm   (:,:,:)        = un_tm   (:,:,:)        + un   (:,:,:)        * e3u_n(:,:,:) 
+         vn_tm   (:,:,:)        = vn_tm   (:,:,:)        + vn   (:,:,:)        * e3v_n(:,:,:) 
+         tsn_tm  (:,:,:,jp_tem) = tsn_tm  (:,:,:,jp_tem) + tsn  (:,:,:,jp_tem) * e3t_n(:,:,:)  
+         tsn_tm  (:,:,:,jp_sal) = tsn_tm  (:,:,:,jp_sal) + tsn  (:,:,:,jp_sal) * e3t_n(:,:,:)  
+         rhop_tm (:,:,:)        = rhop_tm (:,:,:)        + rhop (:,:,:)        * e3t_n(:,:,:)  
+         avs_tm  (:,:,:)        = avs_tm  (:,:,:)        + avs  (:,:,:)        * e3w_n(:,:,:)  
          IF( l_ldfslp ) THEN
             uslp_tm (:,:,:)      = uslp_tm (:,:,:)        + uslp (:,:,:)
@@ -91,27 +125,27 @@
             wslpj_tm(:,:,:)      = wslpj_tm(:,:,:)        + wslpj(:,:,:)
          ENDIF
-# if defined key_trabbl
-          IF( nn_bbl_ldf == 1 ) THEN
-             ahu_bbl_tm(:,:)     = ahu_bbl_tm(:,:)        + ahu_bbl(:,:) 
-             ahv_bbl_tm(:,:)     = ahv_bbl_tm(:,:)        + ahv_bbl(:,:) 
-          ENDIF
-          IF( nn_bbl_adv == 1 ) THEN
-             utr_bbl_tm(:,:)     = utr_bbl_tm(:,:)        + utr_bbl(:,:) 
-             vtr_bbl_tm(:,:)     = vtr_bbl_tm(:,:)        + vtr_bbl(:,:) 
-          ENDIF
-# endif
-          !
-          sshn_tm  (:,:)         = sshn_tm  (:,:)         + sshn  (:,:) 
-          rnf_tm   (:,:)         = rnf_tm   (:,:)         + rnf   (:,:) 
-          h_rnf_tm (:,:)         = h_rnf_tm (:,:)         + h_rnf (:,:) 
-          hmld_tm  (:,:)         = hmld_tm  (:,:)         + hmld  (:,:)
-          fr_i_tm  (:,:)         = fr_i_tm  (:,:)         + fr_i  (:,:)
-          emp_tm   (:,:)         = emp_tm   (:,:)         + emp   (:,:) 
-          fmmflx_tm(:,:)         = fmmflx_tm(:,:)         + fmmflx(:,:)
-          qsr_tm   (:,:)         = qsr_tm   (:,:)         + qsr   (:,:)
-          wndm_tm  (:,:)         = wndm_tm  (:,:)         + wndm  (:,:)
-
+         IF( ln_trabbl ) THEN
+            IF( nn_bbl_ldf == 1 ) THEN
+               ahu_bbl_tm(:,:)     = ahu_bbl_tm(:,:)        + ahu_bbl(:,:) 
+               ahv_bbl_tm(:,:)     = ahv_bbl_tm(:,:)        + ahv_bbl(:,:) 
+            ENDIF
+            IF( nn_bbl_adv == 1 ) THEN
+               utr_bbl_tm(:,:)     = utr_bbl_tm(:,:)        + utr_bbl(:,:) 
+               vtr_bbl_tm(:,:)     = vtr_bbl_tm(:,:)        + vtr_bbl(:,:) 
+            ENDIF
+         ENDIF 
+         !
+         sshn_tm  (:,:)         = sshn_tm  (:,:)         + sshn  (:,:) 
+         rnf_tm   (:,:)         = rnf_tm   (:,:)         + rnf   (:,:) 
+         h_rnf_tm (:,:)         = h_rnf_tm (:,:)         + h_rnf (:,:) 
+         hmld_tm  (:,:)         = hmld_tm  (:,:)         + hmld  (:,:)
+         fr_i_tm  (:,:)         = fr_i_tm  (:,:)         + fr_i  (:,:)
+         emp_tm   (:,:)         = emp_tm   (:,:)         + emp   (:,:) 
+         fmmflx_tm(:,:)         = fmmflx_tm(:,:)         + fmmflx(:,:)
+         qsr_tm   (:,:)         = qsr_tm   (:,:)         + qsr   (:,:)
+         wndm_tm  (:,:)         = wndm_tm  (:,:)         + wndm  (:,:)
+         !
       ELSE                           !  It is time to substep 
-         !   1. set temporary arrays to hold physics variables
+         !   1. set temporary arrays to hold physics/dynamical variables
          un_temp    (:,:,:)      = un    (:,:,:)
          vn_temp    (:,:,:)      = vn    (:,:,:)
@@ -124,14 +158,14 @@
             vslp_temp  (:,:,:)   = vslp  (:,:,:)   ;   wslpj_temp (:,:,:)   = wslpj (:,:,:)
          ENDIF
-# if defined key_trabbl
-          IF( nn_bbl_ldf == 1 ) THEN
-             ahu_bbl_temp(:,:)   = ahu_bbl(:,:)  
-             ahv_bbl_temp(:,:)   = ahv_bbl(:,:) 
-          ENDIF
-          IF( nn_bbl_adv == 1 ) THEN
-             utr_bbl_temp(:,:)   = utr_bbl(:,:) 
-             vtr_bbl_temp(:,:)   = vtr_bbl(:,:) 
-          ENDIF
-# endif
+         IF( ln_trabbl ) THEN
+            IF( nn_bbl_ldf == 1 ) THEN
+               ahu_bbl_temp(:,:)   = ahu_bbl(:,:)  
+               ahv_bbl_temp(:,:)   = ahv_bbl(:,:) 
+            ENDIF
+            IF( nn_bbl_adv == 1 ) THEN
+               utr_bbl_temp(:,:)   = utr_bbl(:,:) 
+               vtr_bbl_temp(:,:)   = vtr_bbl(:,:) 
+            ENDIF
+         ENDIF 
          sshn_temp  (:,:)        = sshn  (:,:)
          sshb_temp  (:,:)        = sshb  (:,:)
@@ -162,14 +196,14 @@
             wslpj_tm (:,:,:)     = wslpj_tm(:,:,:)        + wslpj(:,:,:) 
          ENDIF
-# if defined key_trabbl
-          IF( nn_bbl_ldf == 1 ) THEN
-             ahu_bbl_tm(:,:)     = ahu_bbl_tm(:,:)        + ahu_bbl(:,:) 
-             ahv_bbl_tm(:,:)     = ahv_bbl_tm(:,:)        + ahv_bbl(:,:) 
-          ENDIF
-          IF( nn_bbl_adv == 1 ) THEN
-             utr_bbl_tm(:,:)     = utr_bbl_tm(:,:)        + utr_bbl(:,:) 
-             vtr_bbl_tm(:,:)     = vtr_bbl_tm(:,:)        + vtr_bbl(:,:) 
-          ENDIF
-# endif
+         IF( ln_trabbl ) THEN
+            IF( nn_bbl_ldf == 1 ) THEN
+               ahu_bbl_tm(:,:)     = ahu_bbl_tm(:,:)        + ahu_bbl(:,:) 
+               ahv_bbl_tm(:,:)     = ahv_bbl_tm(:,:)        + ahv_bbl(:,:) 
+            ENDIF
+            IF( nn_bbl_adv == 1 ) THEN
+               utr_bbl_tm(:,:)     = utr_bbl_tm(:,:)        + utr_bbl(:,:) 
+               vtr_bbl_tm(:,:)     = vtr_bbl_tm(:,:)        + vtr_bbl(:,:) 
+            ENDIF
+         ENDIF 
          sshn_tm  (:,:)          = sshn_tm    (:,:)       + sshn  (:,:) 
          rnf_tm   (:,:)          = rnf_tm     (:,:)       + rnf   (:,:) 
@@ -195,14 +229,14 @@
             fmmflx(:,:)          = fmmflx_tm  (:,:) * r1_ndttrc 
             fr_i  (:,:)          = fr_i_tm    (:,:) * r1_ndttrc
-# if defined key_trabbl
-            IF( nn_bbl_ldf == 1 ) THEN
-               ahu_bbl(:,:)      = ahu_bbl_tm (:,:) * r1_ndttrc  
-               ahv_bbl(:,:)      = ahv_bbl_tm (:,:) * r1_ndttrc 
-            ENDIF
-            IF( nn_bbl_adv == 1 ) THEN
-               utr_bbl(:,:)      = utr_bbl_tm (:,:) * r1_ndttrc  
-               vtr_bbl(:,:)      = vtr_bbl_tm (:,:) * r1_ndttrc 
-            ENDIF
-# endif
+            IF( ln_trabbl ) THEN
+               IF( nn_bbl_ldf == 1 ) THEN
+                  ahu_bbl(:,:)      = ahu_bbl_tm (:,:) * r1_ndttrc  
+                  ahv_bbl(:,:)      = ahv_bbl_tm (:,:) * r1_ndttrc 
+               ENDIF
+               IF( nn_bbl_adv == 1 ) THEN
+                  utr_bbl(:,:)      = utr_bbl_tm (:,:) * r1_ndttrc  
+                  vtr_bbl(:,:)      = vtr_bbl_tm (:,:) * r1_ndttrc 
+               ENDIF
+            ENDIF
          ELSE
             wndm  (:,:)          = wndm_tm    (:,:) * r1_ndttrcp1 
@@ -211,14 +245,14 @@
             fmmflx(:,:)          = fmmflx_tm  (:,:) * r1_ndttrcp1 
             fr_i  (:,:)          = fr_i_tm    (:,:) * r1_ndttrcp1 
-# if defined key_trabbl
-            IF( nn_bbl_ldf == 1 ) THEN
-               ahu_bbl(:,:)      = ahu_bbl_tm (:,:) * r1_ndttrcp1  
-               ahv_bbl(:,:)      = ahv_bbl_tm (:,:) * r1_ndttrcp1 
-            ENDIF
-            IF( nn_bbl_adv == 1 ) THEN
-               utr_bbl(:,:)      = utr_bbl_tm (:,:) * r1_ndttrcp1  
-               vtr_bbl(:,:)      = vtr_bbl_tm (:,:) * r1_ndttrcp1 
-            ENDIF
-# endif
+            IF( ln_trabbl ) THEN
+               IF( nn_bbl_ldf == 1 ) THEN
+                  ahu_bbl(:,:)      = ahu_bbl_tm (:,:) * r1_ndttrcp1  
+                  ahv_bbl(:,:)      = ahv_bbl_tm (:,:) * r1_ndttrcp1 
+               ENDIF
+               IF( nn_bbl_adv == 1 ) THEN
+                  utr_bbl(:,:)      = utr_bbl_tm (:,:) * r1_ndttrcp1  
+                  vtr_bbl(:,:)      = vtr_bbl_tm (:,:) * r1_ndttrcp1 
+               ENDIF
+            ENDIF
          ENDIF
          !
@@ -298,19 +332,19 @@
 
       ! Physics variables that are set after initialization:
-      fr_i_tm(:,:) = 0._wp
-      emp_tm (:,:) = 0._wp
+      fr_i_tm  (:,:) = 0._wp
+      emp_tm   (:,:) = 0._wp
       fmmflx_tm(:,:)  = 0._wp
-      qsr_tm (:,:) = 0._wp
-      wndm_tm(:,:) = 0._wp
-# if defined key_trabbl
-      IF( nn_bbl_ldf == 1 ) THEN
-         ahu_bbl_tm(:,:) = 0._wp
-         ahv_bbl_tm(:,:) = 0._wp
-      ENDIF
-      IF( nn_bbl_adv == 1 ) THEN
-         utr_bbl_tm(:,:) = 0._wp
-         vtr_bbl_tm(:,:) = 0._wp
-      ENDIF
-# endif
+      qsr_tm   (:,:) = 0._wp
+      wndm_tm  (:,:) = 0._wp
+      IF( ln_trabbl ) THEN
+         IF( nn_bbl_ldf == 1 ) THEN
+            ahu_bbl_tm(:,:) = 0._wp
+            ahv_bbl_tm(:,:) = 0._wp
+         ENDIF
+         IF( nn_bbl_adv == 1 ) THEN
+            utr_bbl_tm(:,:) = 0._wp
+            vtr_bbl_tm(:,:) = 0._wp
+         ENDIF
+      ENDIF
       !
       IF( nn_timing == 1 )  CALL timing_stop('trc_sub_ini')
@@ -359,14 +393,14 @@
       qsr   (:,:)     =  qsr_temp   (:,:)
       wndm  (:,:)     =  wndm_temp  (:,:)
-# if defined key_trabbl
-      IF( nn_bbl_ldf == 1 ) THEN
-         ahu_bbl(:,:) = ahu_bbl_temp(:,:) 
-         ahv_bbl(:,:) = ahv_bbl_temp(:,:) 
-      ENDIF
-      IF( nn_bbl_adv == 1 ) THEN
-         utr_bbl(:,:) = utr_bbl_temp(:,:) 
-         vtr_bbl(:,:) = vtr_bbl_temp(:,:) 
-      ENDIF
-# endif
+      IF( ln_trabbl ) THEN
+         IF( nn_bbl_ldf == 1 ) THEN
+            ahu_bbl(:,:) = ahu_bbl_temp(:,:) 
+            ahv_bbl(:,:) = ahv_bbl_temp(:,:) 
+         ENDIF
+         IF( nn_bbl_adv == 1 ) THEN
+            utr_bbl(:,:) = utr_bbl_temp(:,:) 
+            vtr_bbl(:,:) = vtr_bbl_temp(:,:) 
+         ENDIF
+      ENDIF
       !
       hdivn (:,:,:)   =  hdivn_temp (:,:,:)
@@ -397,14 +431,14 @@
       qsr_tm     (:,:) = qsr   (:,:)
       wndm_tm    (:,:) = wndm  (:,:)
-# if defined key_trabbl
-      IF( nn_bbl_ldf == 1 ) THEN
-         ahu_bbl_tm(:,:) = ahu_bbl(:,:) 
-         ahv_bbl_tm(:,:) = ahv_bbl(:,:) 
-      ENDIF
-      IF( nn_bbl_adv == 1 ) THEN
-         utr_bbl_tm(:,:) = utr_bbl(:,:) 
-         vtr_bbl_tm(:,:) = vtr_bbl(:,:) 
-      ENDIF
-# endif
+      IF( ln_trabbl ) THEN
+         IF( nn_bbl_ldf == 1 ) THEN
+            ahu_bbl_tm(:,:) = ahu_bbl(:,:) 
+            ahv_bbl_tm(:,:) = ahv_bbl(:,:) 
+         ENDIF
+         IF( nn_bbl_adv == 1 ) THEN
+            utr_bbl_tm(:,:) = utr_bbl(:,:) 
+            vtr_bbl_tm(:,:) = vtr_bbl(:,:) 
+         ENDIF
+      ENDIF
       !
       !
@@ -509,46 +543,46 @@
       !!-------------------------------------------------------------------
       USE lib_mpp, ONLY: ctl_warn
-      INTEGER ::  ierr
-      !!-------------------------------------------------------------------
-      !
-      ALLOCATE( un_temp(jpi,jpj,jpk)        ,  vn_temp(jpi,jpj,jpk)  ,   &
-         &      wn_temp(jpi,jpj,jpk)        ,                            &
-         &      rhop_temp(jpi,jpj,jpk)      ,  rhop_tm(jpi,jpj,jpk) ,   &
-         &      sshn_temp(jpi,jpj)          ,  sshb_temp(jpi,jpj) ,      &
-         &      ssha_temp(jpi,jpj)          ,                           &
-#if defined key_trabbl
-         &      ahu_bbl_temp(jpi,jpj)       ,  ahv_bbl_temp(jpi,jpj),    &
-         &      utr_bbl_temp(jpi,jpj)       ,  vtr_bbl_temp(jpi,jpj),    &
-#endif
-         &      rnf_temp(jpi,jpj)           ,  h_rnf_temp(jpi,jpj) ,     &
-         &      tsn_temp(jpi,jpj,jpk,2)     ,  emp_b_temp(jpi,jpj),      &
-         &      emp_temp(jpi,jpj)           ,  fmmflx_temp(jpi,jpj),     &
-         &      hmld_temp(jpi,jpj)          ,  qsr_temp(jpi,jpj) ,       &
-         &      fr_i_temp(jpi,jpj)          ,  fr_i_tm(jpi,jpj) ,        &
-         &      wndm_temp(jpi,jpj)          ,  wndm_tm(jpi,jpj) ,        &
-         &      avs_tm(jpi,jpj,jpk)         ,  avs_temp(jpi,jpj,jpk) ,   &
-         &      hdivn_temp(jpi,jpj,jpk)     ,  hdivb_temp(jpi,jpj,jpk),  &
-         &      un_tm(jpi,jpj,jpk)          ,  vn_tm(jpi,jpj,jpk)  ,     &
-         &      sshn_tm(jpi,jpj)            ,  sshb_hold(jpi,jpj) ,      &
-         &      tsn_tm(jpi,jpj,jpk,2)       ,                            &
-         &      emp_tm(jpi,jpj)             ,  fmmflx_tm(jpi,jpj)  ,     &
-         &      emp_b_hold(jpi,jpj)         ,                            &
-         &      hmld_tm(jpi,jpj)            ,  qsr_tm(jpi,jpj) ,         &
-#if defined key_trabbl
-         &      ahu_bbl_tm(jpi,jpj)         ,  ahv_bbl_tm(jpi,jpj),      &
-         &      utr_bbl_tm(jpi,jpj)         ,  vtr_bbl_tm(jpi,jpj),      &
-#endif
-         &      rnf_tm(jpi,jpj)             ,  h_rnf_tm(jpi,jpj) , STAT=trc_sub_alloc )  
+      INTEGER ::  ierr(3)
+      !!-------------------------------------------------------------------
+      !
+      ierr(:) = 0
+      !
+      ALLOCATE( un_temp(jpi,jpj,jpk)      ,  vn_temp(jpi,jpj,jpk)   ,     &
+         &      wn_temp(jpi,jpj,jpk)      ,                               &
+         &      rhop_temp(jpi,jpj,jpk)    ,  rhop_tm(jpi,jpj,jpk)   ,     &
+         &      sshn_temp(jpi,jpj)        ,  sshb_temp(jpi,jpj)     ,     &
+         &      ssha_temp(jpi,jpj)        ,                               &
+         &      rnf_temp(jpi,jpj)         ,  h_rnf_temp(jpi,jpj)    ,     &
+         &      tsn_temp(jpi,jpj,jpk,2)   ,  emp_b_temp(jpi,jpj)    ,     &
+         &      emp_temp(jpi,jpj)         ,  fmmflx_temp(jpi,jpj)   ,     &
+         &      hmld_temp(jpi,jpj)        ,  qsr_temp(jpi,jpj)      ,     &
+         &      fr_i_temp(jpi,jpj)        ,  fr_i_tm(jpi,jpj)       ,     &
+         &      wndm_temp(jpi,jpj)        ,  wndm_tm(jpi,jpj)       ,     &
+         &      avs_tm(jpi,jpj,jpk)       ,  avs_temp(jpi,jpj,jpk)  ,     &
+         &      hdivn_temp(jpi,jpj,jpk)   ,  hdivb_temp(jpi,jpj,jpk),     &
+         &      un_tm(jpi,jpj,jpk)        ,  vn_tm(jpi,jpj,jpk)     ,     &
+         &      sshn_tm(jpi,jpj)          ,  sshb_hold(jpi,jpj)     ,     &
+         &      tsn_tm(jpi,jpj,jpk,2)     ,                               &
+         &      emp_tm(jpi,jpj)           ,  fmmflx_tm(jpi,jpj)     ,     &
+         &      emp_b_hold(jpi,jpj)       ,                               &
+         &      hmld_tm(jpi,jpj)          ,  qsr_tm(jpi,jpj)        ,     &
+         &      rnf_tm(jpi,jpj)           ,  h_rnf_tm(jpi,jpj)      , STAT=ierr(1) )  
+      !
+      IF( l_ldfslp ) THEN
+         ALLOCATE( uslp_temp(jpi,jpj,jpk) ,  wslpi_temp(jpi,jpj,jpk),     &
+            &      vslp_temp(jpi,jpj,jpk) ,  wslpj_temp(jpi,jpj,jpk),     &
+            &      uslp_tm  (jpi,jpj,jpk) ,  wslpi_tm  (jpi,jpj,jpk),     &
+            &      vslp_tm  (jpi,jpj,jpk) ,  wslpj_tm  (jpi,jpj,jpk), STAT=ierr(2) )
+      ENDIF
+      IF( ln_trabbl ) THEN
+         ALLOCATE( ahu_bbl_temp(jpi,jpj)  , utr_bbl_temp(jpi,jpj)   ,     &
+            &      ahv_bbl_temp(jpi,jpj)  , vtr_bbl_temp(jpi,jpj)   ,     &
+            &      ahu_bbl_tm  (jpi,jpj)  , utr_bbl_tm  (jpi,jpj)   ,     &
+            &      ahv_bbl_tm  (jpi,jpj)  , vtr_bbl_tm  (jpi,jpj)   , STAT=ierr(3) ) 
+      ENDIF
+      !
+      trc_sub_alloc = MAXVAL( ierr )
       !
       IF( trc_sub_alloc /= 0 )   CALL ctl_warn('trc_sub_alloc: failed to allocate arrays')
-      !
-      IF( l_ldfslp ) THEN
-         ALLOCATE( uslp_temp(jpi,jpj,jpk)   ,  wslpi_temp(jpi,jpj,jpk),      &
-            &      vslp_temp(jpi,jpj,jpk)   ,  wslpj_temp(jpi,jpj,jpk),      &
-            &      uslp_tm  (jpi,jpj,jpk)   ,  wslpi_tm  (jpi,jpj,jpk),      &
-            &      vslp_tm  (jpi,jpj,jpk)   ,  wslpj_tm  (jpi,jpj,jpk),  STAT=trc_sub_alloc )
-      ENDIF
-      !
-      IF( trc_sub_alloc /= 0 )   CALL ctl_warn('trc_sub_alloc: failed to allocate ldf_slp arrays')
       !
    END FUNCTION trc_sub_alloc
